const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const production_operations = sequelize.define(
    'production_operations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

operation_number: {
        type: DataTypes.INTEGER,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"not_started",


"ready",


"in_progress",


"paused",


"completed",


"skipped"

        ],

      },

planned_start: {
        type: DataTypes.DATE,
      
      

      },

planned_end: {
        type: DataTypes.DATE,
      
      

      },

actual_start: {
        type: DataTypes.DATE,
      
      

      },

actual_end: {
        type: DataTypes.DATE,
      
      

      },

good_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

scrap_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  production_operations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.production_operations.belongsTo(db.production_orders, {
      as: 'production_order',
      foreignKey: {
        name: 'production_orderId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.work_centers, {
      as: 'work_center',
      foreignKey: {
        name: 'work_centerId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.machines, {
      as: 'machine',
      foreignKey: {
        name: 'machineId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.users, {
      as: 'operator',
      foreignKey: {
        name: 'operatorId',
      },
      constraints: false,
    });




    db.production_operations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.production_operations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return production_operations;
};


